<?php
declare(strict_types=1);

namespace FiloBlu\Refilo\Plugins;

use Magento\Quote\Model\Quote;
use Throwable;

/**
 * Class Cart
 * @package FiloBlu\Refilo\Plugins
 */
class Cart
{
    /**
     * @param Quote $subject
     * @param $result
     * @return mixed
     */
    public function afterGetExtensionAttributes(Quote $subject, $result)
    {
        try {
            $result->setFilobluSubtotal($subject->getSubtotal());
            $result->setFilobluGrandtotal($subject->getGrandTotal());
            $result->setFilobluShippingEstimated($this->evaluateShippingEstimation($subject));
        } catch (Throwable $throwable) {
            return $result;
        }

        return $result;
    }

    /**
     * @param Quote $quote
     * @return bool
     */
    public function evaluateShippingEstimation(Quote $quote)
    {
        return $quote->getShippingAddress()->validate() !== true;
    }
}
